> ## Documentation Index
> Fetch the complete documentation index at: https://nango-scrips-ref.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Store customer-specific data

> Step-by-step guide on how to store customer-specific data retrievable in your app, in Nango scripts, and on the Nango UI.

Nango lets you store arbitrary metadata on individual [connections](/understand/concepts/connections). This is useful for customizing an integration's behavior per end-customer.

Connection metadata can be set, updated & retrieved with the SDK ([reference](/reference/sdks/node#set-connection-metadata)) & API ([reference](/reference/api/connection/set-metadata)). It can also be retrieved on the Nango UI, in the *Connections* tab> *Select Connection* > *Authorization* tab:

**Set connection metadata**

<Tabs>
  <Tab title="Node">
    ```typescript
    await nango.setMetadata(
        '<INTEGRATION-ID>', 
        '<CONNECTION-ID>', 
        { any_key: 'Any Value' }
    );
    ```
  </Tab>

  <Tab title="REST API">
    ```bash
    curl --request POST \
      --url https://api.nango.dev/connection/<CONNECTION-ID>/metadata \
      --header 'Authorization: Bearer <TOKEN>' \
      --header 'Content-Type: application/json' \
      --header 'Provider-Config-Key: <INTEGRATION-ID>' \
      --data '{ "any_key": "Any Value" }'
    ```
  </Tab>
</Tabs>

**Update connection metadata**

<Tabs>
  <Tab title="Node">
    ```typescript
    await nango.setMetadata(
        '<INTEGRATION-ID>', 
        '<CONNECTION-ID>', 
        { any_key: 'Any Value' }
    );
    ```
  </Tab>

  <Tab title="REST API">
    ```bash
    curl --request PATCH \
      --url https://api.nango.dev/connection/<CONNECTION-ID>/metadata \
      --header 'Authorization: Bearer <TOKEN>' \
      --header 'Content-Type: application/json' \
      --header 'Provider-Config-Key: <INTEGRATION-ID>' \
      --data '{ "any-key": "Any Value" }'
    ```
  </Tab>
</Tabs>

**Get connection metadata**

<Tabs>
  <Tab title="Node">
    ```typescript
    await nango.getMetadata('<INTEGRATION-ID>', '<CONNECTION-ID>');
    ```
  </Tab>

  <Tab title="REST API">
    ```bash

    curl --request GET \
      --url 'https://api.nango.dev/connection/<CONNECTION-ID>?provider_config_key=<INTEGRATION-ID>' \
      --header 'Authorization: Bearer <TOKEN>'

    ```
  </Tab>
</Tabs>

<Tip>
  **Questions, problems, feedback?** Please reach out in the [Slack community](https://nango.dev/slack).
</Tip>
